procedure CONTINUE;
{ CONTINUE waits for a user keypress before continuing, with the exception
  of the following keys which have special meaning:
    P  -  Pauses until P is pressed again (provides protection against an
          accidental keypress clearing the screen).
    S  -  Calls an internal screen dump routine (not implemented).
    F  -  Dumps the current screen image into a PIC file (not implemented).
}
var c: char;
    Checkagain: boolean;

begin
  stopstat;               { erase the graphics status line }

  Checkagain := TRUE;
  while (Checkagain) do begin
    while (NOT keypressed) do
      c := ' ';
    c := readkey;
    c := upcase (c);
    case c of
      'P' : begin  { Pause for another P }
              c := ' ';
              while (c <> 'P') do begin
                repeat until keypressed;
                c := readkey;
                c := upcase (c);
              end; {while}
            end; {option P}
      'S' : begin end; { insert a call to your screen dump here }
      'F' : begin { Dump to a file }
              if not savescrn ('surfmodl.pic') then
                write (chr(7));
            end;
      else
        Checkagain := FALSE;
    end {case}
  end; { while Checkagain }
end; { procedure CONTINUE }
